import matplotlib.pyplot as plt
import numpy as np


def diff_shot():
    x_1 = [i for i in range(0, 6)]
    x_2 = [i for i in range(0, 11)]
    y_hcommon = [38.71, 65.59, 70.25, 78.14, 78.49, 78.14]
    y_hbase = [45.74, 62.40, 68.99, 70.54, 72.48, 71.71]
    y_alluxio = [27.60, 45.16, 51.25, 58.42, 63.08, 63.08, 63.44, 64.16, 64.52, 59.86, 59.50]
    plt.scatter(x_1, y_hcommon,color = "blue")
    plt.scatter(x_1, y_hbase,color = "red")
    plt.scatter(x_2, y_alluxio,color = "green")
    plt.plot(x_1, y_hcommon, color = "blue")
    plt.plot(x_1, y_hbase, color = "red")
    plt.plot(x_2, y_alluxio, color = "green")
    plt.legend(["HCommon", "HBase", "Alluxio"])
    plt.xticks([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
    plt.xlabel("Number of shots")
    plt.ylabel("Percentage of Correct Voting Candidates (CVC)")
    # plt.title("Performance of Code-Davinci-002 model with Different Number of Hints")
    plt.savefig("../figs/diff-shot.png", bbox_inches='tight')

def diff_format():
    x_1 = [i for i in range(0, 6)]
    x_2 = [i for i in range(0, 10)]
    x_3 = [i for i in range(0, 16)]
    y_xml_orig = [38.71, 65.59, 70.25, 78.14, 78.49, 78.14]
    y_kv_orig = [20.07, 44.09, 63.08, 67.74, 69.53, 72.04, 75.63, 76.34, 70.97, 69.53]
    y_xml_wd = [37.63, 63.80, 69.53, 77.42, 82.08, 87.46, 89.25, 89.61, 91.76, 91.04]
    y_kv_wd = [29.39, 58.42, 69.18, 72.04, 78.85, 79.93, 82.44, 86.74, 88.17, 89.61, 89.61, 90.68, 92.11, 94.62, 89.25, 92.11]
    plt.scatter(x_1, y_xml_orig, color = "steelblue")
    plt.scatter(x_2, y_kv_orig, color = "skyblue")
    plt.scatter(x_2, y_xml_wd,color = "red")
    plt.scatter(x_3, y_kv_wd,color = "lightcoral")
    plt.plot(x_1, y_xml_orig, color = "steelblue")
    plt.plot(x_2, y_kv_orig, color = "skyblue")
    plt.plot(x_2, y_xml_wd, color = "red")
    plt.plot(x_3, y_kv_wd, color = "lightcoral")

    plt.text(3, 80, "78.14", weight='bold', fontdict={'fontsize':12, 'color': 'steelblue'}, ha='right', va='bottom')
    plt.text(8, 78, "76.34", weight='bold', fontdict={'fontsize':12, 'color': 'skyblue'}, ha='right', va='bottom')
    plt.text(9, 93, "91.04", weight='bold', fontdict={'fontsize':12, 'color': 'red'}, ha='right', va='bottom')
    plt.text(14, 95, "94.62", weight='bold', fontdict={'fontsize':12, 'color': 'lightcoral'}, ha='right', va='bottom')
    plt.legend(["XML-Orig", "KV-Orig", "XML-Wd", "KV-Wd"])
    plt.xticks([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15])
    plt.xlabel("Number of shots")
    plt.ylabel("Percentage of Correct Voting Candidates (CVC)")
    # plt.title("Performance of Code-Davinci-002 model with Different Number of Hints")
    plt.savefig("../figs/diff-format.png")



def finding11_figure():
    x_1 = [i for i in range(0, 6)]
    x_2 = [i for i in range(0, 10)]
    y_hcommon_xml_orig = [1146, 983, 928, 743, 666, 622]
    y_hcommon_kv_orig = [564, 1399, 1105, 1022, 1004, 1009]
    y_hcommon_xml_wd = [772, 1313, 1175, 915, 738, 541, 492, 418, 372, 351]
    y_hcommon_kv_wd = [979, 1219, 802, 836, 783, 694, 649, 570, 493, 426]
    y_hbase_xml_orig = [612, 741, 667, 558, 493, 739]
    y_hbase_xml_wd = [524, 812, 760, 625, 559, 462, 518, 446, 428, 398]
    y_alluxio_kv_orig = [371, 1221, 1002, 995, 927, 912, 918, 899, 861, 963]
    y_alluxio_kv_wd = [737, 1171, 924, 940, 860, 791, 681, 672, 623, 641] 
    plt.scatter(x_1, y_hcommon_xml_orig, color = "steelblue")
    plt.scatter(x_1, y_hcommon_kv_orig, color = "skyblue")
    plt.scatter(x_2, y_hcommon_xml_wd, color = "red")
    plt.scatter(x_2, y_hcommon_kv_wd, color = "lightcoral")
    plt.scatter(x_1, y_hbase_xml_orig, color = "darkblue")
    plt.scatter(x_2, y_hbase_xml_wd, color = "darkred")
    plt.scatter(x_2, y_alluxio_kv_orig, color = "darkgreen")
    plt.scatter(x_2, y_alluxio_kv_wd, color = "darkcyan")
    plt.plot(x_1, y_hcommon_xml_orig, color = "steelblue")
    plt.plot(x_1, y_hcommon_kv_orig, color = "skyblue")
    plt.plot(x_2, y_hcommon_xml_wd, color = "red")
    plt.plot(x_2, y_hcommon_kv_wd, color = "lightcoral")
    plt.plot(x_1, y_hbase_xml_orig, color = "darkblue")
    plt.plot(x_2, y_hbase_xml_wd, color = "darkred")
    plt.plot(x_2, y_alluxio_kv_orig, color = "darkgreen")
    plt.plot(x_2, y_alluxio_kv_wd, color = "darkcyan")

    plt.legend(["HCommon-XML-Orig", "HCommon-KV-Orig", "HCommon-XML-Wd", "HCommon-KV-Wd", "HBase-XML-Orig", "HBase-XML-Wd", "Alluxio-KV-Orig", "Alluxio-KV-Wd"])
    plt.xlabel("Number of shots")
    plt.ylabel("Number of False Positive")
    plt.savefig("finding11.png")

def diff_model():
    name_list = ['0-shot HCommon','0-shot HBase','0-shot Alluxio','1-shot HCommon', '1-shot HBase', '1-shot Alluxio', '2-shot HCommon', '2-shot Alluxio']
    code_davinci_002 = [38.71, 45.74, 27.60, 65.59, 62.40, 45.16, 70.25, 51.25]
    text_davinci_003 = [0.72, 1.55, 0.72, 21.86, 15.50, 27.60, 34.05, 29.39]
    x =list(range(len(name_list)))
    plt.figure(figsize=(15,4))
    bar_code = plt.bar([i-0.2 for i in x], code_davinci_002, width = 0.4, color = 'firebrick', label='Code-Davinci-002')
    bar_text = plt.bar([i+0.2 for i in x], text_davinci_003, width = 0.4, color = 'navy', label='Text-Davinci-003')
    plt.ylabel("Percentage of Correct Voting Candidates (% CVC)")
    plt.xticks(x, name_list)
    plt.legend()
    plt.savefig("../figs/diff-model.png", bbox_inches='tight')

def metadata_hcommon():
    x_hcommon_wm = [i for i in range(0, 6)]
    y_hcommon_wm = [38.71, 65.59, 70.25, 78.14, 78.49, 78.14]
    x_hcommon_nm = [i for i in range(0, 10)]
    y_hcommon_nm = [37.63, 63.80, 69.53, 77.42, 82.08, 87.46, 89.25, 89.61, 91.76, 91.04]

    fig, ax = plt.subplots(figsize=(10, 4), dpi=100)
    ax.plot(x_hcommon_wm, y_hcommon_wm, label = "With Metadata", color='navy', linestyle='solid', marker='.', markersize='15', markeredgecolor='k',markeredgewidth=1)
    ax.plot(x_hcommon_nm, y_hcommon_nm, label = "Remove Metadata", color='red', linestyle='solid', marker='^', markersize='10', markeredgecolor='k',markeredgewidth=1)
    for x,y in zip(x_hcommon_wm[0:4], y_hcommon_wm[0:4]):
        ax.text(x,y+0.5,'%.2f' % y,fontdict={'fontsize':12, 'color': 'navy'}, ha='right', va='bottom')
    for x,y in zip(x_hcommon_wm[4:], y_hcommon_wm[4:]):
        ax.text(x,y-1,'%.2f' % y,fontdict={'fontsize':12, 'color': 'navy'}, ha='left', va='top')
    for x,y in zip(x_hcommon_nm[0:4], y_hcommon_nm[0:4]):
        ax.text(x,y-2,'%.2f' % y,fontdict={'fontsize':12, 'color': 'red'}, ha='left', va='top')
    for x,y in zip(x_hcommon_nm[4:], y_hcommon_nm[4:]):
        ax.text(x,y,'%.2f' % y,fontdict={'fontsize':12, 'color': 'red'}, ha='right', va='bottom')
    ax.set_xticks([i for i in range(0, 10)]) 
    ax.set_xlabel("HCommon-Number of shots", fontsize=20)
    ax.set_ylabel("% CVC", fontsize=20)
    legend = ax.legend(bbox_to_anchor=(0,1.02,1,0.2), loc="lower left",  borderaxespad=0, ncol=3, handlelength=2, handletextpad=0.3, columnspacing=4, borderpad=0.4, prop={"family": "Times New Roman", "size": 24.5})
    fig.savefig("../figs/hcommon-metadata.png", bbox_inches='tight') 


def metadata_hbase():
    x_hbase_wm = [i for i in range(0, 6)]
    y_hbase_wm = [45.74, 62.40, 68.99, 70.54, 72.48, 71.71]
    x_hbase_nm = [i for i in range(0, 10)]
    y_hbase_nm = [55.81, 72.87, 75.58, 77.52, 77.91, 79.84, 78.68, 82.95, 81.78, 85.27] 

    fig, ax = plt.subplots(figsize=(10, 4), dpi=100)
    ax.plot(x_hbase_wm, y_hbase_wm, label = "With Metadata", color='navy', linestyle='solid', marker='.', markersize='15', markeredgecolor='k',markeredgewidth=1)
    ax.plot(x_hbase_nm, y_hbase_nm, label = "Remove Metadata", color='red', linestyle='solid', marker='^', markersize='10', markeredgecolor='k',markeredgewidth=1)
    for x,y in zip(x_hbase_wm, y_hbase_wm):
        ax.text(x,y-1,'%.2f' % y,fontdict={'fontsize':12, 'color': 'navy'}, ha='left', va='top')
    for x,y in zip(x_hbase_nm, y_hbase_nm):
        ax.text(x,y+0.5,'%.2f' % y,fontdict={'fontsize':12, 'color': 'red'}, ha='right', va='bottom')
    ax.set_xticks([i for i in range(0, 10)]) 
    ax.set_xlabel("HBase-Number of shots", fontsize=20)
    ax.set_ylabel("% CVC", fontsize=20)
    fig.savefig("../figs/hbase-metadata.png", bbox_inches='tight') 


def metadata_alluxio():
    x_alluxio_wm = [i for i in range(0, 11)]
    y_alluxio_wm = [27.60, 45.16, 51.25, 58.42, 63.08, 63.08, 63.44, 64.16, 64.52, 59.86, 59.50]
    x_alluxio_nm = [i for i in range(0, 16)]
    y_alluxio_nm = [36.20, 53.76, 55.91, 63.44, 65.23, 66.67, 69.89, 71.68, 72.40, 72.04, 71.68, 72.40, 70.25, 71.33, 73.84, 72.04]

    fig, ax = plt.subplots(figsize=(10, 4), dpi=100)
    ax.plot(x_alluxio_wm, y_alluxio_wm, label = "With Metadata", color='navy', linestyle='solid', marker='.', markersize='15', markeredgecolor='k',markeredgewidth=1)
    ax.plot(x_alluxio_nm, y_alluxio_nm, label = "Remove Metadata", color='red', linestyle='solid', marker='^', markersize='10', markeredgecolor='k',markeredgewidth=1)
    for x,y in zip(x_alluxio_wm, y_alluxio_wm):
        ax.text(x+0.2,y-0.2,'%.2f' % y,fontdict={'fontsize':8, 'color': 'navy'}, ha='left', va='top')
    for x,y in zip(x_alluxio_nm, y_alluxio_nm):
        ax.text(x,y+0.2,'%.2f' % y,fontdict={'fontsize':8, 'color': 'red'}, ha='right', va='bottom')
    ax.set_xticks([i for i in range(0, 16)])
    ax.set_xlabel("Alluxio-Number of shots", fontsize=20)
    ax.set_ylabel("% CVC", fontsize=20)
    fig.savefig("../figs/alluxio-metadata.png", bbox_inches='tight') 



if __name__ == "__main__":
    diff_model()