import csv
import gspread
import pprint
import sys
import numpy as np
from oauth2client.service_account import ServiceAccountCredentials

#Authorize the API
scope = [
    'https://www.googleapis.com/auth/drive',
    'https://www.googleapis.com/auth/drive.file'
    ]
file_name = 'client_key.json'
creds = ServiceAccountCredentials.from_json_keyfile_name(file_name,scope)
client = gspread.authorize(creds)

def table2():
    for j, i in enumerate(["Zero", "One", "Two", "Three", "Four", "Five"]):
        print(f"{j}hint & \HcommonCodedavinci{i}hintTp & \HcommonCodedavinci{i}hintVc &\ & \HbaseCodedavinci{i}hintTp & \HbaseCodedavinci{i}hintVc &\ & \AlluxioCodedavinci{i}hintTp & \AlluxioCodedavinci{i}hintVc \\\\")


def macro1():
    mode = {"cd":"code-davinci-002", "cc":"code-cushman-001", "td":"text-davinci-003"}
    module = {"hcommon": "xml", "hbase": "xml", "alluxio": "kv"}
    data_label = {"tp":(3,2), "fp":(3,3), "cvc":(3,5), "once":(3,10), "majority":(3,11), "everytime":(3,12)}

    for mu in module.keys():
        for me in mode.keys():
            target_file = f"{mu}#{mode[me]}#{module[mu]}"
            sheet = client.open(target_file).worksheet("Summary")
            for dl in data_label.keys():
                data = sheet.cell(data_label[dl][0], data_label[dl][1]).value.replace("%", "\%")
                print(f"\\newcommand{{\\zerohint{mu}{me}{dl}}}{{{data}\\xspace}}")


def macro2():
    mode = {"cd":"code-davinci-002", "cc":"code-cushman-001", "td":"text-davinci-003"}
    module = {"hcommon": "xml", "hbase": "xml", "alluxio": "kv"}
    data_label = {"tp":(4,2), "fp":(4,3), "cvc":(4,5), "once":(4,10), "majority":(4,11), "everytime":(4,12)}

    for mu in module.keys():
        for me in mode.keys():
            target_file = f"{mu}#{mode[me]}#{module[mu]}"
            sheet = client.open(target_file).worksheet("Summary")
            for dl in data_label.keys():
                data = sheet.cell(data_label[dl][0], data_label[dl][1]).value.replace("%", "\%")
                print(f"\\newcommand{{\\onehint{mu}{me}{dl}}}{{{data}\\xspace}}")


def macro3():
    mode = "Codedavinci"
    hint = ["Zero", "One", "Two", "Three", "Four", "Five"]
    for i in range(len(hint)):
        while (True):
            try:
                hcommontp = client.open(f"hcommon#code-davinci-002#xml").worksheet("Summary").cell(i+3,2).value
                hcommonvc = client.open(f"hcommon#code-davinci-002#xml").worksheet("Summary").cell(i+3,5).value.replace("%", "\%")
                hbasetp = client.open(f"hbase#code-davinci-002#xml").worksheet("Summary").cell(i+3,2).value
                hbasevc = client.open(f"hbase#code-davinci-002#xml").worksheet("Summary").cell(i+3,5).value.replace("%", "\%")
                alluxiotp = client.open(f"alluxio#code-davinci-002#kv").worksheet("Summary").cell(i+3,2).value
                alluxiovc = client.open(f"alluxio#code-davinci-002#kv").worksheet("Summary").cell(i+3,5).value.replace("%", "\%")
                break
            except gspread.exceptions.APIError:
                continue

        print("\\newcommand{\\Hcommon" + mode + hint[i] + "hintTp}{" + hcommontp + "\\xspace}")
        print("\\newcommand{\\Hcommon" + mode + hint[i] + "hintVc}{" + hcommonvc + "\\xspace}")
        print("\\newcommand{\\Hbase" + mode + hint[i] + "hintTp}{" + hbasetp + "\\xspace}")
        print("\\newcommand{\\Hbase" + mode + hint[i] + "hintVc}{" + hbasevc + "\\xspace}")
        print("\\newcommand{\\Alluxio" + mode + hint[i] + "hintTp}{" + alluxiotp + "\\xspace}")
        print("\\newcommand{\\Alluxio" + mode + hint[i] + "hintVc}{" + alluxiovc + "\\xspace}")

if __name__ == "__main__":
    macro2()
